#ifndef I_EXTERN
#define I_EXTERN

#include "window.h"

extern char *strstr();
extern void raw_dump_channel();
extern char *next_arg(char **str);
extern void recreate_chan_mode(), set_chan_mode();
extern void add_users_to_chan();
extern int set_loglevel(int new);
extern win_ptr set_outwin();
extern void reset_outwin();
extern void parse_line(char *str, char *args, int added, int interactive);
extern char *parse_inline(char *str, char *args, int *added);
extern char *expand_alias(char *string, char *args, int *added,
                         char *ret, int len);
extern char *alias_special(char *str, char *args, int *added,
                           char *ret, int len);

extern int getivar(char *var), getbvar(char *var);
extern void setivar(char *var, int value);
extern char *getvar(char *var);
extern void send_notify(), han_notify(server_ptr, char *);

extern win_ptr isquery(server_ptr srv, char *str);
extern char *getquery(void);
extern wild_match();
extern void sl_nick();
extern char *read_input();
extern void replace(), cleanup();

#ifndef IN_QUEUE
extern int *make_new_stack(int is_stack, int type);
extern char *pop_element(int *stack, int type, char **key);
extern void push_element(int *stack, char *key, char *element, int len,
                         int domalloc);
#endif

extern char *get_channel(char *chan);
extern int strncasecmp(char *s1, char *s2, int len), get_chan_num();
extern int strcasecmp(char *s1, char *s2);
extern char *m_strcpy(char *word), *m_copy(char *str, int len);
extern char *grab_param(char **str, char *word);
extern char *m_grab_word(char **str, char let);
extern int grab_word(char **str, char let, char *space);
extern void new_printmess(), forcemess();
extern int lookup_command();
extern void handle_command_line(char *string, int interactive, char *param);
extern void user_alias(char *string), user_assign(char *string, int first);
extern void dobind();
extern void user_dcc(), load_file(), notify(), on(), remap();
extern void user_spawn(), clear_window(), clear_query();
extern void set_query(), set_channel(), delete_windows();
#define whatawho(__x, __y, __z) parse_inline(__x, __y, __z)
char *matching_end(char *, char, char);
extern char *strip_ends(char *str, char x, char y, char *ret, int len);
extern char *m_parse_it(char *str, char *args, int last);
extern int clearquery(), exec_alias(), ignore();
extern int new_send();
extern void help(), user_ignore(), setquery(), updatestatwin(void);
extern void split_window(), window_balance();
extern int handle_on(int type, char *line, int id);
extern int *window_num(), window_hide(), window_delete();
extern void my_sig(), join_channel();
extern int window_select(), *leave_channel();
extern char *get_chan_name();
extern int set_chan_used(), line_split();
extern int lookup_level();
extern win_ptr type_winget();
extern int nslookup(), get_logical();
extern int push_chan();

extern void init_window(), init_binds(), handle_line(), show_level();
extern void init_keybdio(), find_input_prompt(), init_head();
extern void startup(), launch_timer(), free_chan();
extern void get_username();

extern int good_host(), nslookup();
extern char *start_read(short, short, READ_ROUT on_read, READ_ROUT on_exit);
extern void add_connect_to_list(short, SIN *, char *, int type);
extern void print_socket_error(char *);
extern int dynamic_link_module(char *, int, ...);
#endif
